package jp.sf.amateras.javalib.oscache;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;

import com.opensymphony.oscache.base.NeedsRefreshException;
import com.opensymphony.oscache.web.ServletCacheAdministrator;

/**
 * Servlet implementation class OSCacheServlet
 */
public class OSCacheServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		ServletCacheAdministrator cache = ServletCacheAdministrator.getInstance(getServletContext());

		try {
			// キャッシュに値をセット
			cache.putInCache(PageContext.SESSION_SCOPE, request, "key", "value");

			// キャッシュから値を取得
			String value = (String) cache.getFromCache(PageContext.SESSION_SCOPE, request, "key", 60);

			System.out.println(value);

		} catch(NeedsRefreshException ex){
			// キャッシュのリフレッシュが必要な場合
			ex.printStackTrace();
		}
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
	}

}
